use master
GO
IF EXISTS (SELECT * FROM sys.databases WHERE name = 'PartitionDemo')
	DROP DATABASE PartitionDemo
GO
CREATE DATABASE PartitionDemo
GO
use PartitionDemo
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG1
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG2
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG3
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG4
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG5
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG6
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG7
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG8
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File1', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file1.ndf') TO FILEGROUP FG1
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File2', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file2.ndf') TO FILEGROUP FG2
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File3', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file3.ndf') TO FILEGROUP FG3
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File4', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file4.ndf') TO FILEGROUP FG4
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File5', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file5.ndf') TO FILEGROUP FG5
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File6', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file6.ndf') TO FILEGROUP FG6
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File7', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file7.ndf') TO FILEGROUP FG7
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File8', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file8.ndf') TO FILEGROUP FG8
GO
CREATE PARTITION FUNCTION MyPartFunction (datetime)
AS RANGE LEFT FOR VALUES ('20010101', '20020101', '20030101', '20040101', '20050101', '20060101', '20070101');
GO
CREATE PARTITION SCHEME MyPartSchema
AS PARTITION MyPartFunction
ALL TO ([primary]);
GO
CREATE TABLE OrderHistory
(MyId BIGINT IDENTITY(1,1),
OrderDate datetime,
DueDate datetime,
AccountNumber nvarchar(15)
PRIMARY KEY (MyId, OrderDate))
ON MyPartSchema(OrderDate)
GO

CREATE TABLE OrderHistory_ToPurge
(MyId BIGINT IDENTITY(1,1),
OrderDate datetime,
DueDate datetime,
AccountNumber nvarchar(15)
PRIMARY KEY (MyId, OrderDate))
ON MyPartSchema(OrderDate)
GO

INSERT INTO OrderHistory 
(OrderDate, DueDate, AccountNumber)
SELECT OrderDate, DueDate, AccountNumber
FROM AdventureWorks2008R2.Sales.SalesOrderHeader
GO 100

/*View the data in the two tables*/
SELECT *, $Partition.MyPartFunction(OrderHistory.OrderDate) PartitionNumber
FROM OrderHistory 
GO
SELECT *, $Partition.MyPartFunction(OrderHistory_ToPurge.OrderDate) PartitionNumber
FROM OrderHistory_ToPurge 
GO

DBCC IND ('PartitionDemo', 'OrderHistory', 1)
GO
DBCC IND ('PartitionDemo', 'OrderHistory_ToPurge', 1)
GO

/*Switch the data into the ToPurge table*/
ALTER TABLE OrderHistory
SWITCH PARTITION 6 TO dbo.OrderHistory_ToPurge PARTITION 6
GO

ALTER TABLE OrderHistory_ToPurge
SWITCH PARTITION 6 TO dbo.OrderHistory PARTITION 6
GO

/*View the data in the ToPurge table*/
SELECT *, $Partition.MyPartFunction(OrderHistory_ToPurge.OrderDate) PartitionNumber
FROM OrderHistory_ToPurge 
GO

use master
GO
IF EXISTS (SELECT * FROM sys.databases WHERE name = 'PartitionDemo')
	DROP DATABASE PartitionDemo
GO
